{-
    Tests.hs
        Copyright 2008 Matthew Sackman <matthew@wellquite.org>

    This file is part of Session Types for Haskell.

    Session Types for Haskell is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    Session Types for Haskell is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the implied
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Session Types for Haskell.
    If not, see <http://www.gnu.org/licenses/>.
-}

module Control.Concurrent.Session.Tests where

import Control.Concurrent.Session

testProg = cons (SendBool ~> RecvInt ~> jump (D2 E)) $
           cons (offer ((D0 E) ~|~
                        (D1 E) ~|~
                        (D2 E) ~|~ nil)
                ) $
           cons (jump (D0 E)) $
           nil

simpleTestProg = cons (offer ((D1 E) ~|~
                              (D2 E) ~|~ nil)
                      )$
                 cons (SendBool ~> end) $
                 cons (SendChar ~> end) $
                 nil

simpleTestProg' = cons (offer ((D1 E) ~|~
                               (D2 E) ~|~ nil)
                       )$
                  cons (SendBool ~> jump (D0 E)) $
                  cons (SendChar ~> end) $
                  nil

test = run simpleTestProg' (D0 E) p1 p2
    where p1 = sjump ~>>
                soffer ( (sjump ~>> ssend True ~>> p1)
                        :~:
                         (sjump ~>> ssend 'a' ~>> sreturn "Two")
                        :~:
                         OfferImplsNil
                       )
          p2 = sjump ~>>
                sselect (D1 E) ~>>
                 srecv ~>>=
                  (sliftIO . print)

test2 = run simpleTestProg' (D0 E) p1 p2
    where p1 = sjump ~>>
                soffer ( (sjump ~>> ssend True ~>> p1)
                        :~:
                         (sjump ~>> ssend 'a' ~>> sreturn "Two")
                        :~:
                         OfferImplsNil
                       )
          p2 = sjump ~>>
                sselect (D0 E) ~>>
                 srecv ~>>=
                  (sliftIO . print)

test3 = run simpleTestProg' (D0 E) p1 p2
    where p1 = sjump ~>>
                soffer ( (sjump ~>> ssend True ~>> p1)
                        :~:
                         (sjump ~>> ssend 'a' ~>> sreturn "Two")
                        :~:
                         OfferImplsNil
                       )
          p2 = sjump ~>>
                sselect (D0 E) ~>>
                 srecv ~>>=
                  (sliftIO . print) ~>>
                   p2

test4 = run simpleTestProg' (D0 E) p1 p2
    where p1 = sjump ~>>
                soffer ( (sjump ~>> ssend True ~>> p1')
                        :~:
                         (sjump ~>> ssend 'a' ~>> sreturn "Two")
                        :~:
                         OfferImplsNil
                       )
          p1' = sjump ~>>
                soffer ( (sjump ~>> ssend False ~>> p1)
                        :~:
                         (sjump ~>> ssend 'b' ~>> sreturn "Three")
                        :~:
                         OfferImplsNil
                       )
          p2 = sjump ~>>
                sselect (D0 E) ~>>
                 srecv ~>>= \val ->
                  (sliftIO (print val)) ~>>
                   if val then p2 else p2'
          p2' = sjump ~>>
                 sselect (D1 E) ~>>
                  srecv ~>>=
                   (sliftIO . print)
